
//
//  PRotEx.h - Packed Rotation
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This is the rotation module header.
//
//  Created - 1 Sep, 2001 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//


#include    "CpuAsm.h"
#include    "KariType.h"                                // Master Definitions


#ifndef __PRotEx_H
#define __PRotEx_H

#ifdef __cplusplus
extern "C" {
#endif


void PRotSetup( const CpuInfo * const pcinfo );

    //  Shift Right Arithmetic

void vmp_psraBGeneric(  int8  * const pbD, const int8  * const pbA, uint count );
void vmp_psraBAsmMMX(   int8  * const pbD, const int8  * const pbA, uint count );

void vmp_psraHGeneric(  int16 * const phD, const int16 * const phA, uint count );
void vmp_psraHAsmMMX(   int16 * const phD, const int16 * const phA, uint count );

void vmp_psraWGeneric(  int32 * const pwD, const int32 * const pwA, uint count );
void vmp_psraWAsmMMX(   int32 * const pwD, const int32 * const pwA, uint count );


void vmp_psra1BGeneric( int8  * const pbD, const int8  * const pbA );
void vmp_psra1BAsmMMX(  int8  * const pbD, const int8  * const pbA );

void vmp_psra1HGeneric( int16 * const phD, const int16 * const phA );
void vmp_psra1HAsmMMX(  int16 * const phD, const int16 * const phA );

void vmp_psra1WGeneric( int32 * const pwD, const int32 * const pwA );
void vmp_psra1WAsmMMX(  int32 * const pwD, const int32 * const pwA );

    //  Shift Left Logical

void vmp_psllBGeneric(  uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_psllBAsmMMX(   uint8  * const pbD, const uint8  * const pbA, uint count );

void vmp_psllHGeneric(  uint16 * const phD, const uint16 * const phA, uint count );
void vmp_psllHAsmMMX(   uint16 * const phD, const uint16 * const phA, uint count );

void vmp_psllWGeneric(  uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_psllWAsmMMX(   uint32 * const pwD, const uint32 * const pwA, uint count );


void vmp_psll1BGeneric( uint8  * const pbD, const uint8  * const pbA );
void vmp_psll1BAsmMMX(  uint8  * const pbD, const uint8  * const pbA );

void vmp_psll1HGeneric( uint16 * const phD, const uint16 * const phA );
void vmp_psll1HAsmMMX(  uint16 * const phD, const uint16 * const phA );

void vmp_psll1WGeneric( uint32 * const pwD, const uint32 * const pwA );
void vmp_psll1WAsmMMX(  uint32 * const pwD, const uint32 * const pwA );

    //  Shift Right Logical

void vmp_psrlBGeneric(  uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_psrlBAsmMMX(   uint8  * const pbD, const uint8  * const pbA, uint count );

void vmp_psrlHGeneric(  uint16 * const phD, const uint16 * const phA, uint count );
void vmp_psrlHAsmMMX(   uint16 * const phD, const uint16 * const phA, uint count );

void vmp_psrlWGeneric(  uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_psrlWAsmMMX(   uint32 * const pwD, const uint32 * const pwA, uint count );


void vmp_psrl1BGeneric( uint8  * const pbD, const uint8  * const pbA );
void vmp_psrl1BAsmMMX(  uint8  * const pbD, const uint8  * const pbA );

void vmp_psrl1HGeneric( uint16 * const phD, const uint16 * const phA );
void vmp_psrl1HAsmMMX(  uint16 * const phD, const uint16 * const phA );

void vmp_psrl1WGeneric( uint32 * const pwD, const uint32 * const pwA );
void vmp_psrl1WAsmMMX(  uint32 * const pwD, const uint32 * const pwA );

    //  Rotate Left

void vmp_prolBGeneric(  uint8  * const pbD, const uint8  * const pbA, uint count );
void vmp_prolBAsmMMX(   uint8  * const pbD, const uint8  * const pbA, uint count );

void vmp_prolHGeneric(  uint16 * const phD, const uint16 * const phA, uint count );
void vmp_prolHAsmMMX(   uint16 * const phD, const uint16 * const phA, uint count );

void vmp_prolWGeneric(  uint32 * const pwD, const uint32 * const pwA, uint count );
void vmp_prolWAsmMMX(   uint32 * const pwD, const uint32 * const pwA, uint count );


void vmp_prol1BGeneric( uint8  * const pbD, const uint8  * const pbA );
void vmp_prol1BAsmMMX(  uint8  * const pbD, const uint8  * const pbA );

void vmp_prol1HGeneric( uint16 * const phD, const uint16 * const phA );
void vmp_prol1HAsmMMX(  uint16 * const phD, const uint16 * const phA );

void vmp_prol1WGeneric( uint32 * const pwD, const uint32 * const pwA );
void vmp_prol1WAsmMMX(  uint32 * const pwD, const uint32 * const pwA );



#ifdef __cplusplus
}
#endif

#endif  //__PRotEx_H





