  
//
//  Vmd3DEx.h - 3D Math Multiplication & Division
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "CpuAsm.h"
#include    "vmp3D.h"


#ifndef __Vmd3DEx_H
#define __Vmd3DEx_H

#ifdef __cplusplus
extern "C" {
#endif


void Vmd3DSetup( const CpuInfo * const pcinfo );

void vmp_VecMulGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);
void vmp_VecMulAsm3DNow(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);
void vmp_VecMulAsmSSE(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);
void vmp_VecMulAsmSSE0(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);

void vmp_VecScaleGeneric(vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScale );
void vmp_VecScaleAsm3DNow(vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScale );
void vmp_VecScaleAsmSSE(vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScale );
void vmp_VecScaleAsmSSE0(vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScale );

void vmp_VecMAddGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);
void vmp_VecMAddAsm3DNow(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);
void vmp_VecMAddAsmSSE(  vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);
void vmp_VecMAddAsmSSE0( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);

void vmp_VecMSubGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);
void vmp_VecMSubAsm3DNow(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);
void vmp_VecMSubAsmSSE(  vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);
void vmp_VecMSubAsmSSE0( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB, const vmp3DVector * const pvC);

void vmp_VecDivGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );
void vmp_VecDivAsm3DNow( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );
void vmp_VecDivAsmSSE( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );
void vmp_VecDivAsmSSE0( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );

void vmp_VecDivFastAsm3DNow( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );
void vmp_VecDivFastAsmSSE(   vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );
void vmp_VecDivFastAsmSSE0(  vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar );

void vmp_DotProductGeneric(  float * const pfD, const vmp3DVector * const vA, const vmp3DVector * const vB);
void vmp_DotProductAsm3DNow( float * const pfD, const vmp3DVector * const vA, const vmp3DVector * const vB);
void vmp_DotProductAsmSSE(   float * const pfD, const vmp3DVector * const vA, const vmp3DVector * const vB);
void vmp_DotProductAsmSSE0(  float * const pfD, const vmp3DVector * const vA, const vmp3DVector * const vB);

void vmp_CrossProductGeneric( vmp3DVector * const vD, const vmp3DVector* const vA, const vmp3DVector* const vB);
void vmp_CrossProductAsm3DNow(vmp3DVector * const vD, const vmp3DVector* const vA, const vmp3DVector* const vB);
void vmp_CrossProductAsmSSE(  vmp3DVector * const vD, const vmp3DVector* const vA, const vmp3DVector* const vB);
void vmp_CrossProductAsmSSE0( vmp3DVector * const vD, const vmp3DVector* const vA, const vmp3DVector* const vB);


#ifdef __cplusplus
}
#endif

#endif  //__Vmd3DEx_H


