
//
//  util.h - Utilities
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This is the memory, file, management, module header.
//
//  Created - 13 Mar, 2002 - James Leiterman
//
//  Last Modification
//
//  stab=4
//



#ifndef util_H
#define util_H


#ifdef __cplusplus
    extern "C" {
#endif



#ifndef byte
typedef unsigned char           byte;
#endif

#ifndef uint
typedef unsigned int            uint;
#endif

#ifndef ulong
typedef unsigned long           ulong;
#endif




//  Normal Print
#define LOG     printf

//  Verbose
#define VLOG    if (app.bVerbose) printf

//  Error Logs
#define ELOG    printf



//
//  File Handling
//

bool fileLoad( const char * const pFName, byte **ppMem, ulong *uipSize );


char *skipline( const char *p );
char *skipword( const char *p );
char *skipspace( const char *p );
char *getword( char *pBuf, const char *p );
char *getname( char *pszBuf, const char *pszStr );


double pASCIItoDouble( const char **ppStr );

extern int floatXlat;

#ifdef __cplusplus
}
#endif

#endif  //util_H
